<template>
  <div
    class="schedule"
    v-if="part.schedule_day_isset">
    <span :class="status.name">{{ status.text }}</span>
  </div>
</template>

<script>
// "opening_date_time": "2019-05-30 07:00:00",
// "close_date_time": "2019-05-30 21:00:00",
// "dinner_begin_date_time": "2019-05-30 13:00:00",
// "dinner_end_date_time": "2019-05-30 13:30:00",
// "schedule_day_isset": true,
// "around_the_clock": true,
// "current_date_time_with_tz": "2019-05-30 12:42:37.948839"
// Открыто до 18:00   open-to
// Закрыто до 09:00   close-to
// Обед до 14:00      lunch-to
import dayjs from 'dayjs';
import customParseFormat from 'dayjs/plugin/customParseFormat';
import isBetween from 'dayjs/plugin/isBetween';

dayjs.extend(customParseFormat);
dayjs.extend(isBetween);

export default {
  name: 'ScheduleOpenedNow',
  props: {
    part: {
      type: Object,
      default() { return {}; },
    },
  },
  computed: {
    status() {
      const currDateWithTz = dayjs(this.part.current_date_time_with_tz, 'YYYY-MM-DD HH:mm:ss');
      let name = '';
      let text = '';
      if (this.part.around_the_clock) {
        name = 'open-to';
        text = 'Круглосуточно';
      } else if (this.part.opening_date_time
        && this.part.close_date_time
        && this.part.dinner_begin_date_time
        && this.part.dinner_end_date_time) {
        const open = dayjs(this.part.opening_date_time, 'YYYY-MM-DD HH:mm:ss');
        const close = dayjs(this.part.close_date_time, 'YYYY-MM-DD HH:mm:ss');
        const lunchStart = dayjs(this.part.dinner_begin_date_time, 'YYYY-MM-DD HH:mm:ss');
        const lunchEnd = dayjs(this.part.dinner_end_date_time, 'YYYY-MM-DD HH:mm:ss');

        if (
          dayjs(currDateWithTz).isBetween(open, close, null, '[')
          && !dayjs(currDateWithTz).isBetween(lunchStart, lunchEnd, null, '[')
        ) {
          name = 'open-to';
          text = `Открыто до ${close.format('HH:mm')}`;
        } else if (dayjs(currDateWithTz).isBetween(lunchStart, lunchEnd, null, '[')) {
          name = 'lunch-to';
          text = `Обед до ${lunchEnd.format('HH:mm')}`;
        } else {
          name = 'close-to';
          text = `Закрыто до ${open.format('HH:mm')}`;
        }
      } else if (this.part.opening_date_time && this.part.close_date_time) {
        const open = dayjs(this.part.opening_date_time, 'YYYY-MM-DD HH:mm:ss');
        const close = dayjs(this.part.close_date_time, 'YYYY-MM-DD HH:mm:ss');
        if (dayjs(currDateWithTz).isBetween(open, close, null, '[')) {
          name = 'open-to';
          text = `Открыто до ${close.format('HH:mm')}`;
        } else {
          name = 'close-to';
          text = `Закрыто до ${open.format('HH:mm')}`;
        }
      } else if (this.part.dinner_begin_date_time && this.part.dinner_end_date_time) {
        const lunchStart = dayjs(this.part.dinner_begin_date_time, 'YYYY-MM-DD HH:mm:ss');
        const lunchEnd = dayjs(this.part.dinner_end_date_time, 'YYYY-MM-DD HH:mm:ss');
        if (dayjs(currDateWithTz).isBetween(lunchStart, lunchEnd, null, '[')) {
          name = 'lunch-to';
          text = `Обед до ${lunchEnd.format('HH:mm')}`;
        }
      }

      return {
        name,
        text,
      };
    },
  },
};
</script>

<style lang="scss" scoped>
.schedule {
  display: inline-flex;
  white-space: nowrap;

  .open-to, .lunch-to, .close-to {
    &:after {
      content: "";
      display: inline-block;
      vertical-align: middle;
      width: 0.625rem;
      height: 0.625rem;
      border-radius: 50%;
      background-color: #F75A52;
    }
  }
  .open-to:after {
    background-color: #62CE66;
  }
}
</style>
